			list		P=PIC12F683		
 
			#include	<P12F683.INC>

			__config _PWRTE_ON  &_MCLRE_OFF &_WDT_OFF &_INTRC_OSC_NOCLKOUT &_CP_ON &_CPD_OFF &_BOD_OFF & _FCMEN_OFF & _IESO_OFF
;   ID
			__IDLOCS		H'0301'	 ; for PIC12F683 ONLY !!!
;  
    		

			CBLOCK	0x20
TEMP_W			;    (  W  )
CNTPAUSE		;    
COMMAND			;   1-wire
COUNTBIT		;     (   )
READ1WIRE		;     1-wire
ADRFSR			;   ( FSR)
BUF1 : .16		;  1    

CNTBYTECRC		;       (   )
CALCCRC			;    
TEMP2			
CRC2			
CNT2			; 
TRYWRITE		;    
CNTKEY			;   
FLAGS			; . bit1 - 1- 
COUNTER			; 
LEDTIME			;    
TEMP			;   ( )
;     RS232
Tbyte			;  
Tx_Count		;   
SCount    		;   
RCount			;   
FLAG232			;   Ȩ   RS232
TMPFSR			;    FSR   
RS232BUF : 8	; 8         RS232
TEMP_STATUS
Reg_1			;  
Reg_2			;
ADR_EE			;	   EEPROM
MAX_ADR_EE		;     EEPROM
BUF5 : 5		;   5  ( )
DALLAS1
DALLAS2
SLEEP_TIMER		;  
			ENDC
;  ---------------------------
BITLED		EQU		7				;     FLAG232      0-, 1-
#DEFINE 	LEDS	FLAG232, 7			;    0-green 1-red
;#DEFINE			FLAG232, 1
#DEFINE		SLEEP_FLAG		FLAG232, 0	;      
#DEFINE		BYTES_RCVD		FLAG232, 2	;       8     
#DEFINE		BUTTON_PUSH		FLAG232, 6	;      ?
#define		MAX_EEPROM_629		.16 
#define		MAX_EEPROM_683		.32
#define		START_EEPROM		.1
EE_ADR_PIONTER	equ				0		;    eeprom        
EE_MAX_PIONTER	equ				1		;    eeprom       
TMR2INIT		equ				b'01111111'	;   2 ( )  8,  16,  
TIME2SLEEP		equ				0xFF	;   
;---\/------\/------\/------\/------\/------\/------\/------\/------\/---
; cyfral
SIMPLE_COUNTER		equ		TEMP
CYFRAL_COUNT_BIT	equ		COUNTBIT
CYFRAL_BYTE			equ		READ1WIRE
TEMP0_TMR0			equ		CNTPAUSE
TEMP1_TMR0			equ		COMMAND
LEN_TMR0			equ		CALCCRC
LEN2_TMR0			equ		CRC2
;DALLAS1				equ		
;DALLAS2				equ		
; 
#DEFINE FLAG_CYFRAL_ON		FLAG232,	3
#DEFINE FLAG_START_FIND		FLAG232,	4
#DEFINE FLAG_READ_CYFRAL	FLAG232,	5

END_OF_TIMER		equ		.27	;.32
END_OF_TMR1H		equ		.256-END_OF_TIMER

C_PAUSE3			equ		0x03
;CYFRAL_BYTE_START	equ		0x00
CYFRAL_BYTE_START	equ		0xFF
;MASK_CYFRAL		equ 	b'11110000'		; 
MASK_CYFRAL			equ 	b'00001111'		; 
;START_BYTE_CYFRAL	equ		b'01110000'		;  
START_BYTE_CYFRAL	equ		b'00000001'		;  
MASK_4_BIT			equ		b'00000011'		; ,   4,     
END_OF_CYFRAL		equ		.32				; -      

MASK_CMP0 			EQU		b'01000000'
MAX_TMR0_CON		EQU		0X00
MIN_TMR0_CON		EQU		0XFF

;XXXXXXXXXXXXX    XXXXXXXXXXXXXXXXXXX
;constants
MASK_VRCON			equ	b'10001111'			;  
END_OF_TMR1H_ION	equ	.256-.5			;         
AdrEE_VRCON			equ 0x02			;   EEPROM       VRCON

;var
MAX_Vref			equ	LEN_TMR0
MIN_Vref			equ	LEN2_TMR0


;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

ONEWIRE		EQU		0				; 1-wire
BYTE_ONEWIRE	equ b'00000001'

GLED	EQU		1				; ˸ 
BYTE_GLED	equ b'00000010'

TX			EQU		2				;   RS232
BYTE_TX		equ b'00000100'

BUTTON		EQU		3				; 
BYTE_BUTTON	equ b'00001000'

RLED		EQU		4				;  
BYTE_RLED	equ b'00010000'

RX			EQU		5				;  RS232
BYTE_RX		equ b'00100000'

Baudrate    equ     .10      ;  19200 (  = 52 )       

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;- ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM -
;- ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM -
;- ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM - ASM -
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

            ORG     0x0000

            GOTO    main

			org		4
			;

			movwf	TEMP_W				;  _
			SWAPF	STATUS,W			;  _
            BCF     STATUS    , RP0		;  0
			movwf	TEMP_STATUS			;  STATUS
 ;_____________________________ 
;\/ \/ \/ \/ \/ \/ \/ \/ \/ \/
			;   
			BTFSC	INTCON, GPIF 		;  GP ?
			GOTO 	INT_INTE			; !  GP
			; .   
ZACYCL:
			GOTO	WIHOD2				; 

INT_INTE:
			BTFSC	GPIO, BUTTON		;   
			GOTO	PR_MET10			;      RS232    
			BANKSEL	IOC
			MOVLW	(BYTE_RX)			;    
			MOVWF	IOC
			BANKSEL	FLAG232
			BSF		BUTTON_PUSH
			GOTO	PR_MET20
			
PR_MET10
          	call	Recieve
PR_MET20
			MOVF	GPIO, W				;   GPIO   
			BCF		INTCON, GPIF 		;   INTF   INTCON ( , Ĩ )

;/\ /\ /\ /\ /\ /\ /\ /\ /\ /\
;_____________________________   
WIHOD2:
			SWAPF	TEMP_STATUS,W	;    _
			MOVWF	STATUS			;   STATUS_
			SWAPF	TEMP_W,F		;   
			SWAPF	TEMP_W,W		;   STATUS ( SWAPF          MOVF)
			RETFIE					;

;??????????????????????????????????????????????? - 
main		
            BCF     STATUS    , RP0		;  0
			MOVLW	(BYTE_TX | BYTE_RX)			;   GPIO
            MOVWF   GPIO				; GPIO

            MOVLW   0x07
            MOVWF   CMCON0				; 0x19	; CMCON  
 
			BSF     STATUS    , RP0		;  1

			clrf	ANSEL		; 12f683

			MOVLW	(BYTE_ONEWIRE | BYTE_RX)
            MOVWF   TRISIO				; 

			MOVLW	(BYTE_RX)
			MOVWF	WPU

;			MOVLW	NOT_GPPU			;  PULLUP 
			movlw	b'00001000'			;   WDT,  1:1
			MOVWF	OPTION_REG

		;	CALL	0X3FF 				;    ( 12f629)
		;	MOVWF   OSCTUNE		

			MOVLW	(BYTE_BUTTON | BYTE_RX);         
			MOVWF	IOC

			clrf	PIE1				;    
            BCF     STATUS    , RP0		;  0

			clrf	T1CON				;  TMR1,  .,  1:1			
			clrf	PIR1				;    
			movlw	TMR2INIT			;   2 ( )
			movwf	T2CON				;
			

			BCF		INTCON, GPIF 		;   INTF   INTCON
			BSF		INTCON, GIE			;    
			BSF		INTCON, GPIE		;       

			clrf	RCount				;    
			clrf	FLAG232				;  
			clrf	LEDTIME				;

			;   
			BCF		LEDS

;---------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------

            MOVLW   BUF1				;  
            MOVWF   ADRFSR				;     

			movlw	TIME2SLEEP			;   
			movwf	SLEEP_TIMER			;   
			bcf		PIR1, TMR2IF		; 

            CALL    READiBUTTON			;     

			btfsc	SLEEP_FLAG			;  ?
			goto	GO_SLEEP			; 

			BTFSS	BUTTON_PUSH			;   ?
			; , 
			GOTO	MP_MET10
			; 
			CALL	PAUSE006			; 
GO_SLEEP
			bcf		SLEEP_FLAG			;   
MP_MET05	
			BTFSS	GPIO, BUTTON		; Ĩ   
			GOTO	MP_MET05
			CALL	PAUSE006			; 

			BANKSEL	TRISIO				;          SLEEP
			MOVLW	0	;
            MOVWF   TRISIO				;
			MOVLW	(BYTE_BUTTON)		;         
			MOVWF	IOC
			BANKSEL	GPIO				;
			MOVLW	(BYTE_ONEWIRE | BYTE_RX)		;
            MOVWF   GPIO				;
 
			BCF		INTCON, GIE			;  
			MOVF	GPIO, W				;   GPIO   
			BCF		INTCON, GPIF		;  

			sleep
			NOP

			CALL	PAUSE006			; 
;MP_MET07	
;			BTFSS	GPIO, BUTTON		; Ĩ   
;			GOTO	MP_MET07
;			CALL	PAUSE006			; 


COUNT		equ		TEMP
COUNT2		equ		CNTKEY


			clrf	COUNT2				;  

			CLRW				 		;   (     )
			BANKSEL	EEADR				;
			MOVWF	EEADR 				; 
			BSF		EECON1,RD 			; 
			MOVF	EEDAT,W 			; 
			BANKSEL	ADR_EE
			MOVWF	ADR_EE

BTCYCL02:
			MOVLW	.15					; 15   (1 )
			MOVWF	COUNT
BTCYCL01:
			CALL	PAUSE006			; 
;			CALL	PAUSE025			; 
			BTFSC	GPIO, BUTTON		;  ?
			GOTO	BTMETKA10			; , , 
			;  
			DECFSZ	COUNT,F				
			GOTO 	BTCYCL01
			;  Ѩ   
			movf	ADR_EE, W			;     EEPROM ? ,     ,  
			xorlw	START_EEPROM		;
			btfsc	STATUS, Z			;
			goto	BTCYCL01			;

			decf	ADR_EE, W			;      EEPROM? ,    ,    
			xorwf	COUNT2,	W			;
			btfsc	STATUS, Z			;
			goto	BTCYCL01			;

			bsf		GPIO, RLED			; ͨ LED
			bsf		GPIO, GLED			; 
			call	PAUSE006			; 
			bcf		GPIO, RLED			; 
			bcf		GPIO, GLED			; 

			incf	COUNT2,F			;     	
			GOTO 	BTCYCL02			;

BTMETKA10:
			;      
			banksel	GPIO
			MOVLW	(BYTE_TX | BYTE_RX)			;   GPIO
            MOVWF   GPIO				; GPIO
			banksel	TRISIO
			MOVLW	(BYTE_ONEWIRE | BYTE_RX)
            MOVWF   TRISIO				; 
			MOVLW	(BYTE_RX)
			MOVWF	WPU
			MOVLW	(BYTE_BUTTON | BYTE_RX);         
			MOVWF	IOC
			clrf	PIE1				;    
			banksel	T1CON
			clrf	T1CON				;  TMR1,  .,  1:1			
			clrf	PIR1				;    
			BCF		INTCON, GPIF 		;   INTF   INTCON
			BSF		INTCON, GIE			;    
			BSF		INTCON, GPIE		;       
			clrf	RCount				;    
			clrf	FLAG232				;  
			clrf	LEDTIME				;

			movf	COUNT2, F			;    (   ?)
			btfsc	STATUS, Z			;
			GOTO	main				;

			;  8   EEPROM


			BCF		STATUS, C			;   8,     EEPROM
			RLF		COUNT2,F			;
			RLF		COUNT2,F			;
			RLF		COUNT2,F			;

			movlw	.8					; 
			movwf	COUNTER

;			movlw	BUF1				;  RS232BUF,   cyfral
;			btfsc	FLAG_READ_CYFRAL	;
			movlw	RS232BUF			;

            MOVWF   TEMP				;     
BTMETKA20
			MOVF    TEMP      , W		; 
            MOVWF   FSR					;    (  )

			movf	COUNT2, W	 		;   EEPROM 
			BANKSEL	EEADR				;
			MOVWF	EEADR 				; 
			BSF		EECON1,RD 			; 
			MOVF	EEDAT,W 			; 
			BANKSEL	COUNT2				;

            MOVwF    INDF      			;     
 
			INCF	COUNT2, F			;  ר
            INCF    TEMP      , f		;   (  )
            MOVF    TEMP      , W		;  
			decfsz	COUNTER, F
            GOTO    BTMETKA20			; , 8   

			bcf		FLAG_READ_CYFRAL	;    Cyfral    Cyfral
			call	CYFRAL2DALLAS		;

			movlw	BUF1				;  1 (   )
			MOVwF	ADRFSR				;
			btfss	FLAG_READ_CYFRAL	;   CYFRAL?
			GOTO	BT_METAKOM			; 
			; BTCYFRAL
			call	MAIN_CYFRAL2DALLAS	; ,    Dallas
			GOTO	BT_NEXT
BT_METAKOM
			movlw	RS232BUF+2
			call	CHECK_ODD			;   

			movlw	BUF1				;  1 (   )
			MOVwF	ADRFSR				;
			btfss	FLAG_READ_CYFRAL	;    ?
			GOTO	BT_DALLAS			; 
			; BTmetakom
			;,
			movf	RS232BUF+0, W		;   
			btfss	STATUS, Z			;    ?
			GOTO	BT_DALLAS			; 
			xorwf	RS232BUF+1, W		;
			btfss	STATUS, Z			;    ?
			GOTO	BT_DALLAS			; 
			xorwf	RS232BUF+6, W		;
			btfss	STATUS, Z			;    ?
			GOTO	BT_DALLAS			; 
			xorwf	RS232BUF+7, W		;
			btfss	STATUS, Z			;    ?
			GOTO	BT_DALLAS			; 
			call	MAIN_METAKOM2DALLAS	;     METAKOM
			GOTO	BT_NEXT
BT_DALLAS
			bcf		FLAG_READ_CYFRAL
			call	COPYBUFFS
BT_NEXT






MP_MET10
            BCF     STATUS    , RP0		;  0   
			;  
			;   
			BCF		GPIO,	GLED

			;     
			;     RS-232
			
			movlw	RS232BUF			;    cyfral    
			btfsc	FLAG_READ_CYFRAL
			call	SEND_BUFF2UART

			;     (UART)
            MOVLW   BUF1
			call	SEND_BUFF2UART
			
			call	SEND_EEPROM			;    EEPROM

MP_MET85
            CALL    REMOVEiBUTTON		;      

Label_000B  BCF     STATUS    , RP0
            CLRF    TRYWRITE			;    
            CLRF    FLAGS				; 
Label_001C  ;   
			;   
			clrf	LEDTIME				; ,     readibutton     LED
			BSF		LEDS

            MOVLW   BUF1+8				; 
            MOVWF   ADRFSR

			movlw	TIME2SLEEP			;   
			movwf	SLEEP_TIMER			;   
			bcf		PIR1, TMR2IF		; 

            CALL    READiBUTTON			;      

			btfsc	SLEEP_FLAG			;  ?
			goto	GO_SLEEP			; 

			BTFSS	BUTTON_PUSH			;   ?
			; , 
			GOTO	MP_MET30
			; 
			CALL	PAUSE006			; 
MP_MET20	
			BTFSS	GPIO, BUTTON		; Ĩ   
			GOTO	MP_MET20
			CALL	PAUSE006			; 
			GOTO	main

MP_MET30
			movlw	BUF1
            CALL    COMPBUFFS			;   ? (     )
            BTFSS   FLAGS      , 01		;   1 
            GOTO    Label_0005			;  
 			;   ,     
            BCF     STATUS    , RP0		;  0
;     
			BCF		GPIO, RLED
			BSF		GPIO, GLED
			
            CALL    REMOVEiBUTTON		;      
            GOTO    main			;   

			;  ,   
Label_0005  MOVLW   0x03				;   ?
            XORWF   TRYWRITE    , W		; 
            BTFSS   STATUS    , Z		; 
            GOTO    burn			; ,   ,    
            BCF     STATUS    , RP0		; ,    
			;    (  )
			BSF		GPIO, RLED
			BCF		GPIO, GLED

            CALL    REMOVEiBUTTON		;      
            GOTO    main			;   

;   
burn		
			INCF    TRYWRITE    , f		;  
			;   led
			BCF		GPIO, RLED
			

;,,,,,,,,,,,,,,,,,,,,
; RW1990V2  
;''''''''''''''''''''
            BSF     STATUS    , RP0
            BSF     TRISIO, ONEWIRE		;  1-WIRE
            BCF     STATUS    , RP0		;  0
            MOVLW   0x14
            CALL    PAUSE2				;    14   (  )
            BCF     STATUS    , RP0

            MOVLW   0x0A
            MOVWF   TEMP2				;  -    (10 )
Label_000D  CALL    RESETiPRESENCE
            BTFSC   STATUS    , Z		; PRESENCE ?
            GOTO    Label_0009			; 
            CALL    FLASHLED			; 
            GOTO    Label_000B			;    	

Label_0009  MOVLW   0x4F
            CALL    PAUSE1
            DECFSZ  TEMP2      , f		; 
            GOTO    Label_000D
			; 10   PRESENCE  
			; 
            BCF     STATUS    , RP0
            MOVLW   0x1E
            MOVWF   COMMAND
            CALL    WRITE1WIRE			; 1Eh
            MOVLW   0x10
            CALL    PAUSE1				;  
            CALL    RW_1Wire			;  FFh
            BSF     STATUS    , RP0		;  1
            BSF     TRISIO  , ONEWIRE	;  1-WIRE
            BCF     STATUS    , RP0		;  0
            MOVLW   0x18				
            CALL    PAUSE2				;    
            CALL    RESETiPRESENCE		; RESET PRESENCE
            BTFSC   STATUS    , Z		; PRESENCE ?
            GOTO    Label_0010			; 
            CALL    FLASHLED			; 
            GOTO    Label_000B			;    	
			; PRESENCE , 
Label_0010  BCF     STATUS    , RP0		;  0
            MOVLW   0x1D
            MOVWF   COMMAND
            CALL    WRITE1WIRE			;  1Dh
            BCF     STATUS    , RP0
            MOVLW   0x01
            MOVWF   COMMAND
            CALL    BITiWRITE			; - 1
            BSF     STATUS    , RP0
            BSF     TRISIO, ONEWIRE		;  1-WIRE
            BCF     STATUS    , RP0		;  0
            MOVLW   0x18
            CALL    PAUSE2				;    
            CALL    RESETiPRESENCE		; RESET PRESENCE
            BTFSC   STATUS    , Z		; PRESENCE ?
            GOTO    Label_0012			; 
            CALL    FLASHLED			; 
            GOTO    Label_000B			;    
			; PRESENCE , 
Label_0012  MOVLW   0x18
            CALL    PAUSE2				;  
            BCF     STATUS    , RP0
            MOVLW   0x1E
            MOVWF   COMMAND
            CALL    WRITE1WIRE			;  1Eh
            MOVLW   0x10
            CALL    PAUSE1				; 
            CALL    RW_1Wire			;  FFh
            MOVF    READ1WIRE, W		;      READ1WIRE
            XORLW   0xFE				;   FEh
            BTFSC   STATUS    , Z		; ?
            GOTO    Label_0013			;  FEh 
            MOVLW   0x18				; .   FEh
            CALL    PAUSE2				;  
            CALL    RESETiPRESENCE		; RESET PRESENCE
            BTFSC   STATUS    , Z		; PRESENCE ?
            GOTO    Label_0014			; 
            CALL    FLASHLED			; 
            GOTO    Label_000B			;    
			; PRESENCE , 
Label_0014  BCF     STATUS    , RP0
            MOVLW   0xB5
            MOVWF   COMMAND
            CALL    WRITE1WIRE			;  B5h
            MOVLW   0x10
            CALL    PAUSE1				; 
            CALL    RW_1Wire			; 
            MOVF    READ1WIRE, W		;      READ1WIRE
            XORLW   0xFE				;   FEh
            BTFSC   STATUS    , Z		; ?
            GOTO    Label_0015			;  FEh 
            MOVLW   0x18				; .   FEh
            CALL    PAUSE2				;  
            CALL    RESETiPRESENCE		; RESET PRESENCE
            BTFSC   STATUS    , Z		; PRESENCE ?
            GOTO    Label_0016			; 
            CALL    FLASHLED			; 
            GOTO    Label_000B			;    

			; PRESENCE , 
Label_0016  BCF     STATUS    , RP0
            MOVLW   0x3C
            MOVWF   COMMAND
            CALL    WRITE1WIRE			;  3Ch
            BCF     STATUS    , RP0
            MOVLW   0x00
            MOVWF   COMMAND
            CALL    WRITE1WIRE			;  00h
            BCF     STATUS    , RP0
            MOVLW   0x00
            MOVWF   COMMAND
            CALL    WRITE1WIRE			;  00h
            BCF     STATUS    , RP0
            MOVLW   0x55
            MOVWF   COMMAND
            CALL    WRITE1WIRE			;  55h
            MOVLW   0x10
            CALL    PAUSE1				; 
            CALL    RW_1Wire			; 
            MOVF    READ1WIRE, W		;      READ1WIRE
            XORLW   0xBE				;   BEh
            BTFSC   STATUS    , Z		; ?
            GOTO    Label_0017			;  BEh 
            GOTO    Label_0013			; .   BEh, 

;     BEh   55h (  TM2004)
;       5 
;    5 
; 1 -  3Ch (Write ROM), 2-( ), 3-0, 4-  , 5-CRC
Label_0017  BCF     STATUS    , RP0

			BSF		GPIO, ONEWIRE

            MOVLW   BUF5
            MOVWF   FSR					;    1
            MOVLW   0x3C				; 				
            MOVWF   INDF				;   1  3Ch
            MOVLW   BUF5+2
            MOVWF   FSR					;    3
            CLRF    INDF				;  3
            CLRF    CNTKEY				;  
Label_001B  MOVLW   0x18
            CALL    PAUSE2
            CALL    RESETiPRESENCE
            BTFSC   STATUS    , Z
            GOTO    Label_0018
            CALL    FLASHLED
            GOTO    Label_000B			;    

Label_0018  BCF     STATUS    , RP0		;  0
            MOVLW   BUF1
            MOVWF   ADRFSR				;     1
            MOVLW   BUF5+1
            MOVWF   FSR					;    2 
            MOVF    CNTKEY      , W		;  
            MOVWF   INDF				;   2 
            MOVF    ADRFSR      , W		;     	
            ADDWF   CNTKEY      , W		;   
            MOVWF   FSR					;          
            MOVF    INDF      , W		;     
            MOVWF   COMMAND				;     
            MOVLW   BUF5+3				;    4
            MOVWF   FSR					;    4
            MOVF    COMMAND      , W	;  
            MOVWF   INDF				;   4 
            BCF     STATUS    , RP0		;  0
            MOVLW   0x04				
            MOVWF   CNTBYTECRC			; 
            MOVLW   BUF5				;  1 ( )
            CALL    CRCiBUTTON			;    CRC
            MOVLW   BUF5+4
            MOVWF   FSR					;    5
            MOVF    CALCCRC      , W	;    CRC
            MOVWF   INDF				;   5  CRC
            MOVLW   BUF5
            MOVWF   FSR					;   1
Label_001A  MOVF    INDF      , W		;   
            MOVWF   COMMAND				;    
            CALL    WRITE1WIRE			;     1
            MOVLW   0x10
            CALL    PAUSE1
            INCF    FSR       , f		;    
            MOVF    FSR       , W		;  
            XORLW   BUF5+5				;     (5Bh+5)
            BTFSS   STATUS    , Z		; ?
            GOTO    Label_001A			;   
            BCF     STATUS    , RP0		;  0
            MOVLW   0x01
            MOVWF   COMMAND
            CALL    BITiWRITE			;  1
            MOVLW   0x30
            CALL    PAUSE2				;  
            INCF    CNTKEY      , f		;  
            MOVF    CNTKEY      , W		; 
            XORLW   0x08				;   8
            BTFSS   STATUS    , Z		; ?
            GOTO    Label_001B			; ,  
            GOTO    Label_001C			;   

			;     FEh   B5h
Label_0015  MOVLW   0x18
            CALL    PAUSE2
            CALL    RESETiPRESENCE
            BTFSC   STATUS    , Z
            GOTO    Label_001D
            CALL    FLASHLED
            GOTO    Label_000B

Label_001D  BCF     STATUS    , RP0
            MOVLW   0xD1
            MOVWF   COMMAND
            CALL    WRITE1WIRE
            CLRF    COMMAND
            CALL    BITiWRITE
            MOVLW   0x10
            CALL    PAUSE2
            CALL    RESETiPRESENCE
            BTFSC   STATUS    , Z
            GOTO    Label_001E
            CALL    FLASHLED
            GOTO    Label_000B

Label_001E  BCF     STATUS    , RP0
            MOVLW   0xB5
            MOVWF   COMMAND
            CALL    WRITE1WIRE
            MOVLW   0x10
            CALL    PAUSE1
            CALL    RW_1Wire
            MOVF    READ1WIRE, W
            XORLW   0xFF
            BTFSS   STATUS    , Z
            GOTO    Label_0015
            BSF     FLAGS      , 00			;  1 rw1990
            GOTO    Label_0013

;   RW1990 /  
Label_0028  MOVLW   0x18
            CALL    PAUSE2
            CALL    RESETiPRESENCE
            BTFSC   STATUS    , Z
            GOTO    Label_001F
            CALL    FLASHLED
            GOTO    Label_000B

Label_001F  BCF     STATUS    , RP0
            MOVLW   0xD1
            MOVWF   COMMAND
            CALL    WRITE1WIRE			;  D1h
            BCF     STATUS    , RP0
            MOVLW   0x01
            MOVWF   COMMAND
            CALL    BITiWRITE			;  1
            MOVLW   0x18
            CALL    PAUSE2
            CALL    RESETiPRESENCE
            BTFSC   STATUS    , Z
            GOTO    Label_0020
            CALL    FLASHLED
            GOTO    Label_000B

Label_0020  BCF     STATUS    , RP0
            MOVLW   0xB5
            MOVWF   COMMAND				
            CALL    WRITE1WIRE			;  B5h
            MOVLW   0x10
            CALL    PAUSE1
            CALL    RW_1Wire			; 		
            MOVLW   0x18
            CALL    PAUSE2
            CALL    RESETiPRESENCE
            BTFSC   STATUS    , Z
            GOTO    Label_0021
            CALL    FLASHLED
            GOTO    Label_000B
Label_0021  GOTO    Label_001C			;   

			;     FEh   1Eh
Label_0013  BSF     STATUS    , RP0
            BSF     TRISIO     , ONEWIRE
            BCF     STATUS    , RP0		;  0
            MOVLW   0x18
            CALL    PAUSE2
            CALL    RESETiPRESENCE
            BTFSC   STATUS    , Z
            GOTO    Label_0022
            CALL    FLASHLED
            GOTO    Label_000B

;   
;,,,,,,,,,,,,,,,,,,,,
;   EEPROM
;''''''''''''''''''''
Label_0022  MOVLW   0x10
            CALL    PAUSE1
            BCF     STATUS    , RP0
            MOVLW   0xD5
            MOVWF   COMMAND
            CALL    WRITE1WIRE			;  D5h
            BCF     STATUS    , RP0
            MOVLW   0x08				; 8 
            MOVWF   TEMP
            MOVLW   BUF1				; 
            MOVWF   FSR
Label_0026  BTFSS   FLAGS      , 00		;  0 
            GOTO    Label_0023			;  
            COMF    INDF      , W		;  -  -  (  RW1990)
            GOTO    Label_0024
Label_0023  MOVF    INDF      , W		;   -  Ш  (  RW1990)
Label_0024  MOVWF   COMMAND				;      COMMAND
            CALL    LONGWRITE			;        -
            INCF    FSR       , f		;  
            DECFSZ  TEMP      , f		;   ?
            GOTO    Label_0026
            CALL    RESETiPRESENCE
            BTFSC   STATUS    , Z
            GOTO    Label_0027
            CALL    FLASHLED
            GOTO    Label_000B			;    PRESENCE  

Label_0027  BTFSC   FLAGS      , 00		;   RW1990
            GOTO    Label_0028			;  , 
            CALL    SENDiCOMMANDS		;  ,   
            GOTO    Label_001C			;   

;   : Pause-1Ch- 0-ResPres-Pause-1Dh- 0-ResPres-Pause-1Eh-QuikPause-READ-ResPres
SENDiCOMMANDS
Label_0029  MOVLW   0x10
            CALL    PAUSE2				;   10 
            BCF     STATUS    , RP0		;  0
            MOVLW   0x1C
            MOVWF   COMMAND
            CALL    WRITE1WIRE			;  1Ch
            CLRF    COMMAND
            CALL    BITiWRITE			;  0
            CALL    RESETiPRESENCE		; -
            MOVLW   0x10
            CALL    PAUSE2				;   10 
            BCF     STATUS    , RP0		;  0
            MOVLW   0x1D
            MOVWF   COMMAND
            CALL    WRITE1WIRE			;  1Dh
            CLRF    COMMAND
            CALL    BITiWRITE			;  0
            CALL    RESETiPRESENCE		; -
            MOVLW   0x10
            CALL    PAUSE2				;   10 
            BCF     STATUS    , RP0		;  0
            MOVLW   0x1E
            MOVWF   COMMAND
            CALL    WRITE1WIRE			;  1Eh
            MOVLW   0x10
            CALL    PAUSE1				;  
            CALL    RW_1Wire			;    1-wire
            CALL    RESETiPRESENCE		; -
            RETURN

;  
FLASHLED
Label_000A  BCF     STATUS    , RP0
            MOVLW   0x02
            MOVWF   TEMP
Label_002A  

			BCF		GPIO, RLED
			BSF		GPIO, GLED
            MOVLW   0xFF
            CALL    PAUSE2
 
			BSF		GPIO, RLED
			BCF		GPIO, GLED
            MOVLW   0xFF
            CALL    PAUSE2
            DECFSZ  TEMP      , f
            GOTO    Label_002A
            RETURN

;      1-wire      -
LONGWRITE
Label_0025  BSF     STATUS    , RP0			;  1
            BCF     TRISIO     , ONEWIRE	; 0   
            BCF     STATUS    , RP0			;  0
            MOVLW   0x08
            MOVWF   COUNTBIT				; 8 
            BCF     STATUS    , RP0			;  0
Label_002B  BCF     GPIO     , ONEWIRE		;  1-wire
            MOVLW   0x02
            CALL    PAUSE1					; 
            RRF     COMMAND    , f			;   COMMAND
            BTFSC   STATUS    , C			;  
            BSF     GPIO     , ONEWIRE			;   ,    1-wire
            MOVLW   0x0D					;  ,   
            CALL    PAUSE1					; 
            BSF     GPIO     , ONEWIRE		;  
            MOVLW   0x14
            CALL    PAUSE2					;      -
            DECFSZ  COUNTBIT    , f			;  8   ?
            GOTO    Label_002B				; , 
            RETURN							; 

;  RESET    PRESENCE
RESETiPRESENCE
Label_0008  CALL    RESETiBUTTON
            BSF     STATUS    , RP0
            BSF     TRISIO     , ONEWIRE
            BCF     STATUS    , RP0
            CLRF    COUNTER					;  
            CLRF    CNTBYTECRC
Label_002E  BTFSS   GPIO     , ONEWIRE
            GOTO    Label_002D
            NOP
            INCFSZ  CNTBYTECRC   , f
            GOTO    Label_002E
            CLRF    CNTBYTECRC
            INCFSZ  COUNTER      , f		;     
            GOTO    Label_002E
            BCF     STATUS    , Z
            RETURN

Label_002D  BTFSS   GPIO     , ONEWIRE
            GOTO    Label_002D
            BSF     STATUS    , Z
            RETURN

;  ------------------------------------
PAUSE2
			MOVWF   CNT2
Label_0030  MOVLW   0xFF
            MOVWF   CNTPAUSE
Label_002F  DECFSZ  CNTPAUSE      , f
            GOTO    Label_002F
            DECFSZ  CNT2      , f
            GOTO    Label_0030
            RETURN


;    1   FLAGS     1     2 (8 )
; (      -    )
COMPBUFFS	BCF     FLAGS      , 01		;   1
;           MOVLW   BUF1
            MOVWF   TEMP				; 
			clrf	COUNTER

Label_0031  MOVF    TEMP      , W		; 
			addwf	COUNTER, W
            MOVWF   FSR					;    (  )
            MOVF    INDF      , W		;     
            MOVWF   TEMP2				;    38h

;           MOVLW   0x08				;    
;           ADDWF   FSR       , f		;       ( )
			movlw	BUF1+8
			addwf	COUNTER, W
			movwf	FSR
			
            MOVF    INDF      , W		;     
            XORWF   TEMP2      , W		; XOR      
            BTFSS   STATUS    , Z		;  ?
            RETURN						; ,    ( )
;           INCF    TEMP      , f		; , .   (  )
;           MOVF    TEMP      , W		;  

;           XORLW   BUF1+8				;  8 ?
;           BTFSS   STATUS    , Z		;  ?
			incf	COUNTER, F
			movlw	.8
			xorwf	COUNTER, w
			btfss	STATUS, Z

            GOTO    Label_0031			; , 8   
            BSF     FLAGS      , 01		; ,  8  ,    1
            RETURN

;       ------------------------------------------
READiBUTTON

			CLRF    CNT2			;   (     )
            CLRF    CRC2			;   (     )
Label_0036  CALL    WAITiBUTTON		;   ,    RESET

			BTFSC	BUTTON_PUSH		;   ?
			; 
			RETURN
			; , 



;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;       RS232 ب  
;    ب,     CRC
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
			BTFSS	BYTES_RCVD		;  RS232  8 ?
			; , 
			GOTO	MET30
			; , 

			bcf		FLAG_READ_CYFRAL	;    Cyfral    Cyfral
			call	CYFRAL2DALLAS		;

			movlw	BUF1				;  1 (   )
			MOVwF	ADRFSR				;
			btfss	FLAG_READ_CYFRAL	;   CYFRAL?
			GOTO	RB_DALLAS
			; CYFRAL
			call	MAIN_CYFRAL2DALLAS	; ,    Dallas
			GOTO	RB_NEXT
RB_DALLAS
			;   
			call	COPYBUFFS
RB_NEXT

		;	CALL	COPYBUFFS
		;	BCF		BYTES_RCVD
		;	BCF		FLAG232, 1
			GOTO	MET40
			

MET30
			;  CYFRAL ?
			btfsc	FLAG_CYFRAL_ON		;  CYFRAL ?
			goto	CR_MET010			; 
			goto	MET37				;
CR_MET010	
			call	ION					;  
			btfss	FLAG_CYFRAL_ON		;   ?
			goto	Label_0036			;  (  )
			call	cyfral				;  ,     cyfral
			;call	CYFRAL_CONT			;   
			btfsc	FLAG_READ_CYFRAL	;  CYFRAL ?
			goto	CR_MET020			; , 
			call	metakom				; ,   metakom
			btfss	FLAG_READ_CYFRAL	;  CYFRAL ?
			GOTO	Label_0036			;  (  )
			; , 
			;    DALLAS   
			call	MAIN_METAKOM2DALLAS
 			; , 
	;		bcf		FLAG_READ_CYFRAL	;       UART  

			GOTO	MET40
CR_MET020
			; , 
			;    DALLAS   
			call	MAIN_CYFRAL2DALLAS
 			; , 
			GOTO	MET40

MET37		;  dallas

            BCF     STATUS    , RP0	;  0
            MOVLW   0x33
            MOVWF   COMMAND			;   33h <READ ROM>
            CALL    WRITE1WIRE		;      1-wire
            MOVLW   0x04			;   4 
            CALL    PAUSE1		; 
            BCF     STATUS    , RP0	;  0
            MOVLW   0x08
            MOVWF   TEMP			; 8    ( )
            MOVF    ADRFSR      , W	;     25h
            MOVWF   FSR				;  
Label_0033  CALL    RW_1Wire		;      1-wire (   24h)
            MOVF    READ1WIRE, W	;   
            MOVWF   INDF			;  
            INCF    FSR       , f	;    
            DECFSZ  TEMP      , f	;   ?
            GOTO    Label_0033		; ,   
	        BCF     STATUS    , RP0	;  0

MET40			; 8  
            MOVLW   0x07
            MOVWF   CNTBYTECRC		; 7   CNTBYTECRC (   )
            MOVF    ADRFSR      , W	;     
            CALL    CRCiBUTTON		;   
            MOVF    ADRFSR      , W	;     
            ADDLW   0x07			;        (  )
            MOVWF   FSR				;    
            MOVF    INDF      , W	;     
            XORWF   CALCCRC     , W	;      
            BTFSS   STATUS    , Z	;  ?
            GOTO    Label_0034		; ,  
            GOTO    Label_0035		; , 

			; ,  

			;    ,     :  5    CRC
			;      
			;      CRC .

Label_0034  
;                  
;			goto	Label_0036_		; ,   
;                  

			MOVF    ADRFSR      , W	;  
            ADDLW   0x07			;   ,     CRC
            MOVWF   FSR				;   
            MOVF    INDF      , W	;  CRC
            XORWF   CRC2      , f	; XOR CRC   CRC2
            BTFSS   STATUS    , Z	; ?
            CLRF    CNT2			; ,   CNT2
			; 
            INCF    CNT2      , f	;  . CNT2 
            MOVF    CNT2      , W	;
            XORLW   0x05			;  5 ?
            BTFSC   STATUS    , Z	; 
            GOTO    Label_0035		; ,   5, 
            MOVF    ADRFSR      , W	;   
            ADDLW   0x07			;   
            MOVWF   FSR				;  
            MOVF    INDF      , W	;  CRC
            MOVWF   CRC2			; 
            GOTO    Label_0036_		;       

Label_0035  MOVF    CALCCRC     , W	;   
            BTFSC   STATUS    , Z
            GOTO    Label_0036_		;       , ..    
			BTFSS	BYTES_RCVD		;       UART
			;    UART
			RETURN			;  ,   , 
            ;  UART
			BCF		BYTES_RCVD
			BCF		FLAG232, 1

            RETURN					;  ,   , 


Label_0036_	;   UART FF00FF    CRC
			BTFSS	BYTES_RCVD			;       UART
			goto	Label_0036			; ,   UART
			;  UART
			MOVLW	0XFF
            MOVWF   Tbyte				;    Tbyte
            call	Transmit			;    
			MOVLW	0X00
            MOVWF   Tbyte				;    Tbyte
            call	Transmit			;    
			MOVLW	0XFF
            MOVWF   Tbyte				;    Tbyte
            call	Transmit			;    

			BCF		BYTES_RCVD
			BCF		FLAG232, 1


			GOTO    Label_0036

;    
CRCiBUTTON
			MOVWF   FSR
            BCF     STATUS    , RP0
            MOVLW   0x08
            MOVWF   TEMP
            CLRF    CALCCRC			;     
Label_003B  MOVF    INDF      , W
            MOVWF   TEMP2
Label_003A  MOVF    CALCCRC    , W
            XORWF   TEMP2      , W
            ANDLW   0x01
            XORLW   0x01
            BTFSC   STATUS    , Z
            GOTO    Label_0037
            GOTO    Label_0038
Label_0037  MOVF    CALCCRC      , W
            XORLW   0x18
            MOVWF   CALCCRC
            BCF     STATUS    , C
            RRF     CALCCRC      , f
            MOVF    CALCCRC      , W
            IORLW   0x80
            MOVWF   CALCCRC
            GOTO    Label_0039

Label_0038  BCF     STATUS    , C
            RRF     CALCCRC      , f
Label_0039  BCF     STATUS    , C
            RRF     TEMP2      , f
            DECFSZ  TEMP      , f
            GOTO    Label_003A
            INCF    FSR       , f
            BCF     STATUS    , RP0
            MOVLW   0x08
            MOVWF   TEMP
            DECFSZ  CNTBYTECRC     , f
            GOTO    Label_003B
            RETURN

;  RESET
RESETiBUTTON
			BSF     STATUS    , RP0		;  1
            BCF     TRISIO, ONEWIRE		; 1-wire -  
            BCF     STATUS    , RP0		;  0
            BCF     GPIO , ONEWIRE		; 1-wire   
            BCF     STATUS    , RP0		;   0
            MOVLW   0x9F
            MOVWF   TEMP				;   9fh
Label_003C  DECFSZ  TEMP      , f		;  
            GOTO    Label_003C			;      
			;  
            BSF     STATUS    , RP0		;  1
            BSF     TRISIO, ONEWIRE		; 1-wire   ( )
            BCF     STATUS    , RP0		;  0 !!!	!!!	!!!	     0 
            RETURN
;   RESET


;--------------------------------------------------------------------------------------------------
		; /   1-Wire (   W=0FFh).  TEMP1

RW_1Wire	 
					BSF			STATUS, RP0				;  1
			 		bsf			GPIO,ONEWIRE             ;  1-Wire
					BCF			STATUS, RP0				;  0
			 		bcf			GPIO,ONEWIRE             ;   
				 	movlw		08h                   	;8 
				 	movwf		COUNTBIT	; COUNTER
RWLoop			 
					BSF			STATUS, RP0				;  1
			 		bcf			GPIO,ONEWIRE             ;  1-Wire
					BCF			STATUS, RP0				;  0

					BSF			STATUS, RP0				;  1
					bsf			GPIO,ONEWIRE             ;  1-Wire
					BCF			STATUS, RP0				;  0

					rrf			READ1WIRE,F             ;   
					movlw		0Feh					;  ~12 
RW_1label       	addlw		01h
					BTFSS		STATUS, Z	;	jnz       RW_1label
					GOTO		RW_1label
				 	bcf			READ1WIRE,7               ;    TEMP1
					btfsc		GPIO,ONEWIRE
					bsf			READ1WIRE,7
								
					movlw		D'220'                ;    
RW_2label       	addlw		01h
					BTFSS		STATUS, Z
					GOTO		RW_2label

					decfsz		COUNTBIT, F	;	COUNTER,F			 ;8  ?
					goto		RWLoop                ;  - 

;
					return							 ;  /   1-Wire
;--------------------------------------------------------------------------------------------------

;        1-wire. -   CAMMAND  
BITiWRITE
			BSF     STATUS    , RP0		;  1
            BCF     TRISIO     , ONEWIRE		; 0   
            BCF     STATUS    , RP0		;  0
            BCF     GPIO     , ONEWIRE		;  1-wire
            MOVLW   0x02
            CALL    PAUSE1				; 
            RRF     COMMAND     , f		;   COMMAND 
            BTFSC   STATUS    , C		;  
            BSF     GPIO     , ONEWIRE		;   ,    (1 -> 1-wire)
            MOVLW   0x0D				;    (0 -> 1-wire)
            CALL    PAUSE1				; 
            BSF     GPIO     , ONEWIRE		
            MOVLW   0x02
            CALL    PAUSE1				; 
            RETURN

;  b    1-wire
WRITE1WIRE
			BSF     STATUS    , RP0
            BCF     TRISIO     , ONEWIRE		; 1-wire  
            BCF     STATUS    , RP0
            MOVLW   0x08
            MOVWF   COUNTBIT			;   (    (   ))
            BCF     STATUS    , RP0
Label_003E  BCF     GPIO     , ONEWIRE		;    1-wire
            MOVLW   0x02				;   2 
            CALL    PAUSE1			;  
            RRF     COMMAND     , f		;    
            BTFSC   STATUS    , C		;   (   )
            BSF     GPIO     , ONEWIRE		;   , 1-wire   1
            MOVLW   0x0D				;   13 
            CALL    PAUSE1			; 
            BSF     GPIO     , ONEWIRE		; 1-wire  1
            MOVLW   0x02				;   2 
            CALL    PAUSE1			; 
            DECFSZ  COUNTBIT    , f		;   ,   ?
            GOTO    Label_003E			;     
            RETURN


;    ,     
REMOVEiBUTTON
			BCF     STATUS    , RP0
            MOVLW   0xFF
            MOVWF   TEMP2
Label_0042  CLRF    TEMP
            BSF     STATUS    , RP0
            BSF     TRISIO     , ONEWIRE
            BCF     STATUS    , RP0
Label_0040  BTFSS   GPIO     , ONEWIRE
            GOTO    Label_003F
            INCFSZ  TEMP      , f
            GOTO    Label_0040
            GOTO    Label_0041
Label_003F  BTFSS   GPIO     , ONEWIRE
            GOTO    Label_003F
            MOVLW   0xEE
            CALL    PAUSE1
            CALL    RESETiBUTTON
            GOTO    REMOVEiBUTTON

Label_0041  CALL    RESETiBUTTON
            DECFSZ  TEMP2      , f
            GOTO    Label_0042
            RETURN						;  , 

;     W
PAUSE1
Label_000C  MOVWF   CNTPAUSE
Label_0043  DECFSZ  CNTPAUSE      , f
            GOTO    Label_0043
            RETURN

;  (   1-wire,   ,    ) -----------------------------
WAITiBUTTON

			btfss	PIR1,	TMR2IF	;    2 ( )
			goto	NOT_OVERFLOW_TMR2	;  , 
			; 
			bcf		PIR1,	TMR2IF
			movf	SLEEP_TIMER, F	;   
			btfss	STATUS, Z		;
			goto	NOT_Z_SLEEP
			; 
			bsf		SLEEP_FLAG		;   
			return
NOT_Z_SLEEP
			decf	SLEEP_TIMER, F
NOT_OVERFLOW_TMR2
			

			INCF	LEDTIME, F
			BTFSC	LEDTIME, 7
			GOTO	WBMET05
			;  
			banksel GPIO
			btfss	FLAG232, 7	;   	0- 1-
			goto 	SET_GREEN
			goto	SET_RED

SET_GREEN	
			BCF		GPIO, RLED
			BSF		GPIO, GLED
			GOTO	WBMET01
SET_RED		
			BSF		GPIO, RLED
			BCF		GPIO, GLED
WBMET01
			GOTO	WBMET10
WBMET05
			;  
			BCF		GPIO, RLED
			BCF		GPIO, GLED

WBMET10
			BCF     STATUS    , RP0	;  0

			BTFSC	BYTES_RCVD		;  RS232  8 ?
			; 
			RETURN
			; , 

			BTFSC	BUTTON_PUSH		;   ?
			; 
			RETURN
			; , 


            MOVLW   0x00
            MOVWF   TEMP			;  
Label_0045  BSF     STATUS    , RP0	;  1
            BSF     TRISIO, ONEWIRE	;  1-wire   ( )
            BCF     STATUS    , RP0	;  0
            BTFSS   GPIO  , ONEWIRE	;   ?
            GOTO    Label_0044		; ,  , 
            INCF    TEMP      , f	;  
            MOVF    TEMP      , W	;  
            XORLW   0x7D			;   (  7D,  ,   )
            BTFSS   STATUS    , Z	;  ?
            GOTO    Label_0045		; ,  

            CALL    RESETiBUTTON	;  ,    RESET
            GOTO    WAITiBUTTON		;   

;    
Label_0044  

			call	CYFRAL_TEST			;  CYFRAL ?
			btfsc	FLAG_CYFRAL_ON		;
			return						;   cyfral
			call	EXIT_ERROR			;    
			; goto	CR_MET010			; 

			BTFSS   GPIO  , ONEWIRE	;  ?
            GOTO    Label_0044		; , 
			; , ,            
			clrf	TEMP
LBL_XXX
			BTFSS   GPIO  , ONEWIRE		;  ?
			goto	WAITiBUTTON			; ,  ,   

            INCF    TEMP      , f	;  
            MOVF    TEMP      , W	;  
            XORLW   0x20			;  
            BTFSS   STATUS    , Z	;  ?
            GOTO    LBL_XXX			; ,  

            RETURN					
 
;__________________________________________________________________________________

;----------   (       TByte) --------
Transmit:    
;			bsf    Flags,0          ;      
            movlw  .8
            movwf  Tx_Count         ;   =8
            bcf    GPIO, TX          ;    (=0)
Next_Tx     call   Delay
            btfss  Tbyte,0          ;     (     )
            goto   Zero             ;   -  ,  ,   
            bsf    GPIO, TX          ;  
            goto   One
Zero        bcf    GPIO, TX          ;  
One         rrf    Tbyte,1          ;     (  Tbyte )
            decfsz Tx_Count,1       ;      ,    ,    
            goto   Next_Tx          ;     
            call   Delay            ;    
            bsf    GPIO, TX          ;  -
            call   Delay            ;  (     -    )
            clrf   Tbyte            ;   TByte
 ;           bcf    Flags,0          ;     
            return

;-----   (    -) ----------------------
;-----          --------------------------------
;-----     ,       ---
Recieve    btfsc GPIO, RX           ;  =0,   - 
           goto  Exit
   ;        btfsc Flags,1           ;  -   ,
   ;        goto  Err_overflow      ;  ,      
           bsf   FLAG232,1           ;    
           movlw .8
           movwf Tx_Count          ;   =8
           call  Delay2            ;  = 1/4   (     ,    )
Next_Rx    call  Delay             ;
           bcf   STATUS,0          ;   cf
           rrf   Tbyte,1           ;   
           btfsc GPIO, RX          ;  =1,   1,   - 
           bsf   Tbyte,7           ;  =1
           decfsz Tx_Count,1       ;     -  8   
           goto  Next_Rx           ;   -   
           call  Delay
           btfsc GPIO, RX           ;  =0,     
           goto  Exit
 
;          bsf   Flags,3           ;      -  
			BCF		FLAG232, 1		;    
			CLRF	RCount			;  -  
           goto  Exit2

;Err_overflow bsf   Flags,2         ;   
			
Exit:       
			BTFSS	BYTES_RCVD		;   8 ?
			GOTO	MET20			; .  8 , 
			;  
			BCF		BYTES_RCVD		;  , ͨ   
			CLRF	RCount			;  ר
;			return
MET20
			MOVF	FSR,	W		;  FSR
			MOVWF	TMPFSR			;  FSR

			MOVF	RCount, W		;  ר
			ADDLW	RS232BUF		;    
			MOVWF	FSR				;  
			
			MOVF	Tbyte, W		; 
			MOVWF	INDF			;   
			incf	RCount,	F		;  -  
			MOVF	RCount, W		;  
			XORLW	0X08			; 
			BTFSC	STATUS, Z		;  ?
			; .  
			BSF		BYTES_RCVD		;  8 
			;  
			
			MOVF	TMPFSR, W		;    FSR
			MOVWF	FSR				;  
Exit2:
			return

;---- /4 --------------------------------------------
Delay2     movlw Baudrate
           movwf SCount
           bcf   STATUS,0
           rrf   SCount,1
           bcf   STATUS,0
           rrf   SCount,1           
Next2      nop
           decfsz SCount,1
           goto Next2
           return
;------------------------------------------------------------


;---- ,    baudrate (    9   1,029    4 ) ---
Delay      movlw Baudrate
           movwf SCount
Next       nop
           decfsz SCount,1
           goto Next
           return

;______________________________________________________________________________________________________________________________________________
			;   0.06 . 
;delay = 60'000 machine cycles
PAUSE006:
			movlw       .225
            movwf       Reg_1
            movlw       .78
            movwf       Reg_2
wr2         decfsz      Reg_1, F
            goto        wr2
            decfsz      Reg_2, F
            goto        wr2
			RETURN	;
;______________________________________________________________________________________________________________________________________________

WriteEE:
    	BANKSEL		EEDAT
    	movwf    	EEDAT
		BANKSEL		ADR_EE
    	movF    	ADR_EE, W				; 
		BANKSEL		EEADR
    	movwf    	EEADR
    	bsf        	EECON1,WREN         ;Enable write
    	bcf        	INTCON, GIE         ;Disable INTs
    	btfsc    	INTCON, GIE         ;See AN576
		goto    	$-2 
    	movlw     	0x55                ;Unlock write
    	movwf     	EECON2 
    	movlw     	0xAA
    	movwf     	EECON2 
    	bsf     	EECON1, WR          ;Start the write
WaitForEEWrite
    	btfsc   	EECON1, WR          ;wait for hardware to clear (done writing)
    	goto    	WaitForEEWrite
    	bcf     	STATUS    , RP0     ;Bank0
    	bsf     	INTCON, GIE         ;Enable INTS
		BANKSEL		ADR_EE
		RETURN

;  
;     RS-232 (UART)
SEND_BUFF2UART
            MOVWF   TEMP				;     
			movlw	.8					;   8 
			movwf	COUNTER
Cycl01		MOVF    TEMP      , W		; 
            MOVWF   FSR					;    (  )
            MOVF    INDF      , W		;     
            MOVWF   Tbyte				;    Tbyte
            call	Transmit			;    
            INCF    TEMP      , f		;   (  )
            MOVF    TEMP      , W		;  
          ;  XORLW   BUF1+8				;  ? ( 8 ?)
          ;  BTFSS   STATUS    , Z		;  ?
			decfsz	COUNTER, F			;  8 ?
            GOTO    Cycl01				; , 8   
           ; ,  8  
			RETURN



;^^^^^^^^^^^^^^^^^
;    EEPROM
;^^^^^^^^^^^^^^^^^

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SEND_EEPROM
			movlw	EE_ADR_PIONTER 		;       eeprom
			BANKSEL	EEADR				;
			MOVWF	EEADR 				; 
			BSF		EECON1,RD 			; 
			MOVF	EEDAT,W 			; 
			BANKSEL	MAX_ADR_EE
			MOVWF	MAX_ADR_EE
			
			BCF		STATUS, C			;   8,    
			RLF		MAX_ADR_EE,F		;
			RLF		MAX_ADR_EE,F		;
			RLF		MAX_ADR_EE,F		;

			movf	MAX_ADR_EE, W		;           ?
			SUBLW	START_EEPROM * 8	; 
			BTFSC	STATUS, C			; START_EEPROM-MAX_ADR_EE
			;  	(  C=1)	START_EEPROM>=MAX_ADR_EE
			GOTO	MP_MET80
			;      ( C=0)		START_EEPROM<MAX_ADR_EE

			movlw	(START_EEPROM * 8)	;   
			BANKSEL	EEADR				;
			MOVWF	EEADR 				; 
			BANKSEL	TEMP				;
Cycl20
            MOVLW   BUF1+8				;  
            MOVWF   TEMP				;     BUF1+8
Cycl10		
			MOVF    TEMP      , W		; 
            MOVWF   FSR					;    (  )

			BANKSEL	EECON1				;	      C  
			BSF		EECON1,RD 			; 
			MOVF	EEDAT,W 			; 
			INCF	EEADR, F			;
			BANKSEL	TEMP				;
			MOVWF	INDF				;
			INCF	TEMP, F				;
	
            MOVF    TEMP      , W		;  
            XORLW   BUF1+.16				;  ? ( 8 ?)
            BTFSS   STATUS    , Z		;  ?
            GOTO    Cycl10				; , 8   

			movlw	BUF1				;  RS232BUF,   cyfral
			btfsc	FLAG_READ_CYFRAL	;
			movlw	RS232BUF			;

            CALL    COMPBUFFS			;   ? (     )
            BTFSC   FLAGS      , 01		;   1 
 			;   
            return;GOTO  MP_MET85				;      EEPROM
 			;   
			

			BANKSEL EEADR
			movf	EEADR, W			;   
			BANKSEL	MAX_ADR_EE
			XORWF	MAX_ADR_EE, W		; 
			BTFSS	STATUS, Z			; 
			;  Ѩ  (  Z=0)
			GOTO	Cycl20
			; Ѩ  (Z=1)	
			;        EEPROM

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MP_MET80
			MOVLW	EE_MAX_PIONTER		;   EEPROM      EEPROM
			BANKSEL	EEADR				;
			MOVWF	EEADR 				;
			BSF		EECON1,RD 			;
			MOVF	EEDAT,W 			;
			BANKSEL	MAX_ADR_EE			;
			MOVWF	MAX_ADR_EE			;

			MOVLW	MAX_EEPROM_683		;      12F683, ,  
			XORWF	MAX_ADR_EE, W		;
			BTFSC	STATUS, Z			;
			GOTO	MP_MET50			;

			MOVLW	MAX_EEPROM_629		;      12F629  12F675, ,  
			XORWF	MAX_ADR_EE, W				;
			BTFSC	STATUS, Z			;
			GOTO	MP_MET50			;

			MOVLW	MAX_EEPROM_629		;      12f629
			MOVWF	MAX_ADR_EE			;


MP_MET50


			CLRW				 		;  
			BANKSEL	EEADR				;
			MOVWF	EEADR 				; Address to read
			BSF		EECON1,RD 			; EE Read
			MOVF	EEDAT,W 			; Move data to W
			BANKSEL	ADR_EE
			MOVWF	ADR_EE
			
			BCF		STATUS, C			;   8,      EEPROM
			RLF		ADR_EE,F			;
			RLF		ADR_EE,F			;
			RLF		ADR_EE,F			;

			movlw	.8					; 
			movwf	COUNTER

			movlw	BUF1				;  RS232BUF,   cyfral
			btfsc	FLAG_READ_CYFRAL	;
			movlw	RS232BUF			;

            MOVWF   TEMP				;     
Cycl02		MOVF    TEMP      , W		; 
            MOVWF   FSR					;    (  )

            MOVF    INDF      , W		;     
            call	WriteEE				;   EEPROM

			INCF	ADR_EE, F			;  ר
            INCF    TEMP      , f		;   (  )
            MOVF    TEMP      , W		;  
  ;          XORLW   BUF1+8				;  ? ( 8 ?)
  ;          BTFSS   STATUS    , Z		;  ?
			decfsz	COUNTER, F
            GOTO    Cycl02				; , 8   

			BCF		STATUS, C			;   8,      EEPROM
			RRF		ADR_EE,F			;
			RRF		ADR_EE,F			;
			RRF		ADR_EE,F			;

			MOVF	MAX_ADR_EE, W		;  ר   
			SUBWF	ADR_EE, W			; 
			BTFSS	STATUS, C			; ADR_EE-MAX_ADR_EE
			; Ѩ  ( C=0)		ADR_EE<MAX_ADR_EE
			GOTO	MP_MET60
			; 	(  C=1)	ADR_EE>=MAX_ADR_EE
			MOVLW	START_EEPROM
			MOVWF	ADR_EE	

MP_MET60
			MOVF	ADR_EE, W			;  ר  
			CLRF	ADR_EE				;
            call	WriteEE				; 
			return
;^^^^^^^^^^^^^^^^^



;**************************************************************************************************
;		org 0x3ff					;  pic12f683
;		retlw	0x00
;**************************************************************************************************

;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
;*CYFRAL***CYFRAL***CYFRAL***CYFRAL***CYFRAL***CYFRAL***CYFRAL***CYFRAL***CYFRAL***CYFRAL***CYFRAL*
;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$



;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;    ?
;           CYFRAL
;          
;         EXIT_ERROR
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

CYFRAL_TEST
			bcf		FLAG_CYFRAL_ON
			banksel	VRCON
  			; VREN=1 - VREF circuit powered on
			; VREF=0 - High Range; VREF = 1/4 * VDD + (VR<3:0>/ 32) * VDD = 3,59375
            MOVLW    b'10001111'		;
            MOVWF   VRCON				;
			bsf		TRISIO, ONEWIRE

 			banksel	CMCON0
			; Comparator 2 Output 
			; 1 = C2 VIN+ < C2 VIN- 
			; 0 = C2 VIN+ > C2 VIN-
			;-0 C1OUT: Comparator 1 Output 0 = C1 VIN+ < C1 VIN
			;1 C2INV: Comparator 2 Output ---Inversion--- C2 Output inverted
			;-0 C1INV: Comparator 1 Output Inversion 0 = C1 Output not inverted
			;1 CIS: Comparator Input Switch 1 = C1 VIN- connects to RA3 C2 VIN- connects to ---RA2---
			;010 CM2:CM0: Comparator Mode

			; C2out=1 if Vref < Inp
			; C2out=0 if Vref > Inp
			MOVLW   b'00011110'
            MOVWF   CMCON0				;
            MOVLW   C_PAUSE3			;
            CALL    PAUSE_CYFRAL
            BTFSC   CMCON0, COUT		;  , 
;            GOTO    EXIT_ERROR			;   Vref (3,6V) < Inp
			return						;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			; Inp<3.6V
			
			banksel	VRCON
			; VREN=1 - VREF circuit powered on
			; VRR=1 - Low Range
			; VREF = (VR<3:0>/ 24) * VDD = 0.625
            MOVLW   b'10100011'	
            MOVWF   VRCON				; 
			banksel	CMCON0
            MOVLW   C_PAUSE3			; 
            CALL    PAUSE_CYFRAL
            BTFSS   CMCON0, COUT		;  , 
;            GOTO    EXIT_ERROR			;   Vref (0,625V) > Inp
			return						;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 			; Inp>0.625V
			; 0.625V<Inp<3.6V
			bsf		FLAG_CYFRAL_ON
			return						;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


CYFRAL_CONT
			CALL	ION
			goto	cyfral				;    

; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;  
; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

;proc
ION
			bcf		FLAG_CYFRAL_ON		;  
			banksel	VRCON				;     
			; VREN=1 - VREF circuit powered on
			; VRR=0 - High Range
			; VREF = (VR<3:0>/ 24) * VDD = 2.5
            MOVLW   b'10001111'			;
            MOVWF   VRCON				; 
			banksel	CMCON0				;
            MOVLW   C_PAUSE3			; 
            CALL    PAUSE_CYFRAL		;

Vref_MC01
			movlw	END_OF_TMR1H_ION	;  
			movwf	TMR1H				;
			clrf	TMR1L				;
			bcf		PIR1, TMR1IF		;
			bsf		T1CON, TMR1ON		;
		;	clrf	TMR0				;

Vref_CYCL10
			BTFSC	CMCON0, COUT		;    ?
			GOTO	MAX_FOUND			; 
										; 
			btfsc	PIR1, TMR1IF		;  Ҩ  ?
			GOTO	HIGH2LOW		;
			GOTO	Vref_CYCL10			; 
MAX_FOUND
			banksel	VRCON				;         
			movlw	MASK_VRCON			;
			andwf	VRCON, W			;
			banksel	MAX_Vref			;
			movwf	MAX_Vref			;

Vref_MC02
			banksel	VRCON				;     
			; VREN=1 - VREF circuit powered on
			; VRR=0 - High Range
			; VREF = (VR<3:0>/ 24) * VDD = 1.25
            MOVLW   b'10000000';		;
            MOVWF   VRCON				; 
			banksel	CMCON0				;
            MOVLW   C_PAUSE3			; 
            CALL    PAUSE_CYFRAL		;

			movlw	END_OF_TMR1H_ION	;  
			movwf	TMR1H				;
			clrf	TMR1L				;
			bcf		PIR1, TMR1IF		;
		;	bsf		T1CON, TMR1ON		;

Vref_CYCL20	
			BTFSC	CMCON0, COUT		;    ?
			GOTO	MIN_FOUND			; 
										; 
			btfsc	PIR1, TMR1IF		;  Ҩ  ?
			GOTO	LOW2HIGH		;
			GOTO	Vref_CYCL20			; 

MIN_FOUND
			banksel	VRCON				;         
			movlw	MASK_VRCON			;
			andwf	VRCON, W			;
			banksel	MIN_Vref			;
			movwf	MIN_Vref			;

            MOVF    MIN_Vref, W			;    
            SUBWF   MAX_Vref, F			; MAX_Vref = MAX_Vref - MIN_Vref
			bcf		STATUS, C			;
            RRF     MAX_Vref, W			; MAX_Vref/2
            ANDLW   MASK_VRCON			; 
            ADDWF   MIN_Vref, W			; MAX_Vref/2 + MIN_Vref
			banksel	VRCON
            MOVWF   VRCON
        ;    BCF     VRCON, VREN		;  
            BCF     STATUS    , RP0		;  0
            MOVLW   C_PAUSE3			;
            CALL    PAUSE_CYFRAL		;

			;goto	cyfral				;    
			bsf		FLAG_CYFRAL_ON		;   (  )
			return						;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HIGH2LOW
			movlw	MASK_VRCON			;  
			banksel	VRCON				; 
			andwf	VRCON, W			;
			banksel	CMCON0				;
			btfsc	STATUS, Z			;
			goto	EXIT_ERROR			;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			banksel	VRCON				; 
			decf	VRCON, F			;
			banksel	CMCON0				;
            MOVLW   C_PAUSE3			;
            CALL    PAUSE_CYFRAL		;
			goto	Vref_MC01			;

LOW2HIGH
			movlw	MASK_VRCON			;  
			banksel	VRCON				; 
			andwf	VRCON, W			;
			xorlw	b'00001111'			;
			banksel	CMCON0				;
			btfsc	STATUS, Z			;
			goto	EXIT_ERROR			;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			banksel	VRCON				; 
			incf	VRCON, F			;
			banksel	CMCON0				;
            MOVLW   C_PAUSE3			;
            CALL    PAUSE_CYFRAL		;
			goto	Vref_MC02			;

; 
;   cyfral
; 
cyfral
			movlw	RS232BUF+7			;   
			movwf	FSR					;
;			clrf	FLAG				;
			bcf		FLAG_START_FIND
			bcf		FLAG_READ_CYFRAL
			clrf	CYFRAL_COUNT_BIT	;
			movlw	CYFRAL_BYTE_START	;
			movwf	CYFRAL_BYTE			;
;			clrf	TMR0_COUNT			;
			movlw	END_OF_TMR1H		;  
			movwf	TMR1H				;
			clrf	TMR1L				;
			bcf		PIR1, TMR1IF		;
			bsf		T1CON, TMR1ON		;
			clrf	TMR0				;

CYF_CYCL05
			BTFSC	CMCON0, COUT		;    ?
			GOTO	CYF_MET010_YES		; 
										; 
;			MOVF	TMR0_COUNT, W		;  Ҩ  ?
;			XORLW	END_OF_TIMER		;
;			BTFSC	STATUS, Z			;
			btfsc	PIR1, TMR1IF		;
			GOTO	EXIT_ERROR_T		;
			GOTO	CYF_CYCL05			; 
CYF_MET010_YES
CYF_CYCL07
			BTFSS	CMCON0, COUT		;    ?
			GOTO	CYF_MET020_YES		; 
										; 
;			MOVF	TMR0_COUNT, W		;  Ҩ  ?
;			XORLW	END_OF_TIMER		;
;			BTFSC	STATUS, Z			;
			btfsc	PIR1, TMR1IF		;
			GOTO	EXIT_ERROR_T		;
			GOTO	CYF_CYCL07			; 
CYF_MET020_YES
			MOVF	TMR0, W				;    0
CYF_CYCL10
			MOVWF	TEMP0_TMR0			;
CYF_CYCL15
			BTFSC	CMCON0, COUT		;    ?
			GOTO	CYF_MET030_YES		; 
										; 
;			MOVF	TMR0_COUNT, W		;  Ҩ  ?
;			XORLW	END_OF_TIMER		;
;			BTFSC	STATUS, Z			;
			btfsc	PIR1, TMR1IF		;
			GOTO	EXIT_ERROR_T		;
			GOTO	CYF_CYCL15			; 
CYF_MET030_YES
			MOVF	TMR0, W				;    0
			MOVWF	TEMP1_TMR0			;

			MOVF	TEMP0_TMR0, W		;    
			SUBWF	TEMP1_TMR0, W		;
			MOVWF	LEN_TMR0			;

			MOVF	TEMP1_TMR0, W		;   TMR0   
			MOVWF	TEMP0_TMR0			;
			
CYF_CYCL20
			BTFSS	CMCON0, COUT		;    ?
			GOTO	CYF_MET040_YES		; 
										; 
;			MOVF	TMR0_COUNT, W		;  Ҩ  ?
;			XORLW	END_OF_TIMER		;
;			BTFSC	STATUS, Z			;
			btfsc	PIR1, TMR1IF		;
			GOTO	EXIT_ERROR_T		;
			GOTO	CYF_CYCL20			; 
CYF_MET040_YES
			MOVF	TMR0, W				;    0
			MOVWF	TEMP1_TMR0			;
			
			MOVF	TEMP0_TMR0, W		;    
			SUBWF	TEMP1_TMR0, W		;
			MOVWF	LEN2_TMR0			;

;			MOVF	LEN2_TMR0, W		;    
;			SUBWF	LEN_TMR0, W			; LEN_TMR0 - LEN2_TMR0 (LEN_TMR0<LEN2_TMR0 |C=0| bit clear; LEN_TMR0>=LEN2_TMR0 |C=1| bit set)
;			RRF		CYFRAL_BYTE, F

			MOVF	LEN_TMR0, W			;    
			SUBWF	LEN2_TMR0, W		; LEN2_TMR0 - LEN_TMR0 (LEN2_TMR0<LEN_TMR0 |C=0| bit clear; LEN2_TMR0>=LEN_TMR0 |C=1| bit set)
			RLF		CYFRAL_BYTE, F

			btfsc	FLAG_START_FIND		;    ?
			GOTO	CYF_MET50			; 
			; 
			movlw	MASK_CYFRAL			;   
			andwf	CYFRAL_BYTE, W		;
			xorlw	START_BYTE_CYFRAL	;
			btfsc	STATUS, Z			;
			bsf		FLAG_START_FIND		; 

			bcf		T1CON, TMR1ON		;
			movlw	END_OF_TMR1H		;   1
			movwf	TMR1H				;
			clrf	TMR1L				;
			bsf		T1CON, TMR1ON		;
			
			goto	CYF_MET60			;

CYF_MET50	;    
			incf	CYFRAL_COUNT_BIT, F	;   

			movlw	MASK_4_BIT			;  ?
			andwf	CYFRAL_COUNT_BIT, W	;
			btfss	STATUS, Z			;
			goto	CYF_MET60			; ,   ,   
			
			; ,  
			movlw	MASK_CYFRAL			; 
			andwf	CYFRAL_BYTE, W		;
			

;
;      - 
;
			movwf	INDF					;   
			decf	FSR, F

			movlw	END_OF_CYFRAL		;     
			xorwf	CYFRAL_COUNT_BIT, W	;
			btfsc	STATUS, Z			;
			goto	EXIT_OK				; 
			
			
			
CYF_MET60	;   ,   

			MOVF	TEMP1_TMR0, W		;   TMR0   
		;	MOVWF	TEMP0_TMR0			;

			GOTO	CYF_CYCL10			; 



EXIT_OK 	; 
			;      (  eeprom   )
			movlw	AdrEE_VRCON	 		;   EEPROM       VRCON
			BANKSEL	EEADR				;
			MOVWF	EEADR 				; Address to read
			BSF		EECON1,RD 			; EE Read
			MOVF	EEDAT,W 			; Move data to W
			BANKSEL	ADR_EE
			MOVWF	ADR_EE
			incf	ADR_EE, W			;   0xff
			btfsc	STATUS, Z			; 
			goto	EXT_pryg10			;    ( eeprom FF,   )

			banksel VRCON				; 
			movf	VRCON, W			;
			banksel	ADR_EE				;
			call 	WriteEE				;

;   dallas
CYFRAL2DALLAS
EXT_pryg10
			movlw	RS232BUF			; 
			movwf	FSR					;
			movlw	.8					; 8  
			movwf	SIMPLE_COUNTER
			clrf	DALLAS1
			clrf	DALLAS2

CONVERT_CYCL
			MOVF    INDF      , W
            ADDLW   0xF9				;  7 ?
            BTFSC   STATUS    , Z
            GOTO    CONVERT_07
            ADDLW   0xFC				;  B ?
            BTFSC   STATUS    , Z
            GOTO    CONVERT_0B
            ADDLW   0xFE				;  D ?
            BTFSC   STATUS    , Z
            GOTO    CONVERT_0D
            ADDLW   0xFF				;  E ?
            BTFSS   STATUS    , Z
            GOTO	EXIT_ERROR				;  
            ADDLW   0x40				;  E  '11000000'
CONVERT_0D  ADDLW   0x40				;  D  '10000000
CONVERT_0B  ADDLW   0x40				;  B  '01000000
CONVERT_07  BCF     STATUS    , C		;  7  '00000000
            RRF     DALLAS2   , F
            RRF     DALLAS1   , F
            RRF     DALLAS2   , F
            RRF     DALLAS1   , F
            ADDWF   DALLAS2   , F
            INCF    FSR       , F
			decfsz	SIMPLE_COUNTER, F
            GOTO    CONVERT_CYCL

			;     
			bsf		FLAG_READ_CYFRAL
EXIT_ERROR_T
EXIT02
MTM_EXIT_ERROR
EXIT_ERROR	; 
;			goto	$
            MOVLW   0x07					;  
			banksel CMCON0
            MOVWF   CMCON0
			banksel	VRCON
            BCF     VRCON, VREN				;  
            BCF     STATUS    , RP0			;  0
			bcf		T1CON, TMR1ON			;  1
            MOVLW   C_PAUSE3				;
            CALL    PAUSE_CYFRAL
			return


PAUSE_CYFRAL
			MOVWF   CNTPAUSE
PAUSECYCL	NOP
            NOP
            DECFSZ  CNTPAUSE, F
            GOTO    PAUSECYCL
            RETURN


;##################################################################
;     Dallas   Cyfral
MAIN_CYFRAL2DALLAS							
			MOVF	ADRFSR, W
			MOVWF	FSR

			movlw	0x01
			movwf	INDF
			incf	FSR, F

			movf	DALLAS1, W
			movwf	INDF
			incf	FSR, F

			movf	DALLAS2, W
			movwf	INDF
			incf	FSR, F

			movlw	0x01
			movwf	INDF
			incf	FSR, F

			clrf	INDF
			incf	FSR, F

			clrf	INDF
			incf	FSR, F

			clrf	INDF

            MOVLW   0x07
            MOVWF   CNTBYTECRC		; 7   (   )
            MOVF    ADRFSR      , W	;     
            CALL    CRCiBUTTON		;   
            MOVF    ADRFSR      , W	;     
            ADDLW   0x07			;        (  )
            MOVWF   FSR				;    
			movf	CALCCRC, W
            MOVWF   INDF			;     

			return

;##################################################################
;     Dallas   METAKOM
MAIN_METAKOM2DALLAS							
			MOVF	ADRFSR, W
			MOVWF	FSR

			movlw	0x01
			movwf	INDF
			incf	FSR, F

			movf	RS232BUF+5, W
			movwf	INDF
			incf	FSR, F

			movf	RS232BUF+4, W
			movwf	INDF
			incf	FSR, F

			movf	RS232BUF+3,	W
			movwf	INDF
			incf	FSR, F

			movf	RS232BUF+2, W
			movwf	INDF
			incf	FSR, F

			clrf	INDF
			incf	FSR, F

			clrf	INDF

			clrf	RS232BUF+0
			clrf	RS232BUF+1
			clrf	RS232BUF+6
			clrf	RS232BUF+7

            MOVLW   0x07
            MOVWF   CNTBYTECRC		; 7   (   )
            MOVF    ADRFSR      , W	;     
            CALL    CRCiBUTTON		;   
            MOVF    ADRFSR      , W	;     
            ADDLW   0x07			;        (  )
            MOVWF   FSR				;    
			movf	CALCCRC, W
            MOVWF   INDF			;     

			return

; 
;   metakom
; 
METAKOM_COUNT_BIT	equ		CYFRAL_COUNT_BIT
LEN_TAU				equ		CYFRAL_BYTE
END_OF_METAKOM		equ		.3+.4*.8	; -      (3  + 32 )
C_PAUSE_LONG		equ		0xff

metakom
			bcf		FLAG_READ_CYFRAL	;  
			banksel	CMCON0				;  
			MOVLW   b'00000111'			;
            MOVWF   CMCON0				;
			banksel	TRISIO				;  
			bcf		TRISIO, ONEWIRE		;
            BsF     VRCON, VREN			;  
			banksel	GPIO				;
			bcf		GPIO,	ONEWIRE		;
            MOVLW   C_PAUSE_LONG		;
            CALL    PAUSE_CYFRAL		;
            CALL    PAUSE_CYFRAL		;

			clrwdt						;    wdt  tmr0
			banksel	OPTION_REG			;
			movlw	b'00000000'			;  1:2
			movwf	OPTION_REG			;
			banksel	TMR0				;
			clrf	TMR0				;

			movlw	RS232BUF+7			;   
			movwf	FSR					;
;			clrf	FLAG				;
;			bcf		FLAG_START_FIND
;			bcf		FLAG_READ_CYFRAL
;			clrf	CYFRAL_COUNT_BIT	;
;			movlw	CYFRAL_BYTE_START	;
;			movwf	CYFRAL_BYTE			;

			movlw	END_OF_METAKOM		;
			movwf	METAKOM_COUNT_BIT	;
;			clrf	TMR0_COUNT			;
			movlw	END_OF_TMR1H		;  
			movwf	TMR1H				;
			clrf	TMR1L				;
			bcf		PIR1, TMR1IF		;
			bsf		T1CON, TMR1ON		;
			clrf	TMR0				;

			banksel	GPIO				;   
			bsf		GPIO,	ONEWIRE		;
			banksel	TRISIO				; 
			bsf		TRISIO, ONEWIRE		;
			banksel	CMCON0				;  
			MOVLW   b'00011110'			;
            MOVWF   CMCON0				;
			nop
           ; MOVLW   C_PAUSE3			;
           ; CALL    PAUSE01				;

MTM2_CYCL05
			BTFSs	CMCON0, COUT		;    ?
			GOTO	MTM2_MET010_YES		; 
										; 
			btfsc	PIR1, TMR1IF		; Ҩ  ?
			GOTO	MTM_EXIT_ERROR		;
			GOTO	MTM2_CYCL05			; 
MTM2_MET010_YES
			MOVF	TMR0, W				;    0
			MOVWF	TEMP0_TMR0			;
MTM2_CYCL07
			BTFSc	CMCON0, COUT		;    ?
			GOTO	MTM2_MET020_YES		; 
										; 
			btfsc	PIR1, TMR1IF		; Ҩ  ?
			GOTO	MTM_EXIT_ERROR		;
			GOTO	MTM2_CYCL07			; 
MTM2_MET020_YES
			MOVF	TMR0, W				;    0
			MOVWF	TEMP1_TMR0			;

			MOVF	TEMP0_TMR0, W		;    
			SUBWF	TEMP1_TMR0, W		;
			MOVWF	LEN_TAU				;   (   )

;   
			MOVF	TEMP1_TMR0, W		;   TMR0   
MTM_CYCL10
			MOVWF	TEMP0_TMR0			;
MTM_CYCL15
			BTFSs	CMCON0, COUT		;    ?
			GOTO	MTM_MET030_YES		; 
										; 
			btfsc	PIR1, TMR1IF		; Ҩ  ?
			GOTO	MTM_EXIT_ERROR		;
			GOTO	MTM_CYCL15			; 
MTM_MET030_YES
			MOVF	TMR0, W				;    0
			MOVWF	TEMP1_TMR0			;

			MOVF	TEMP0_TMR0, W		;    
			SUBWF	TEMP1_TMR0, W		;
			MOVWF	LEN_TMR0			;

			MOVF	TEMP1_TMR0, W		;   TMR0   
			MOVWF	TEMP0_TMR0			;
			
MTM_CYCL20
			BTFSc	CMCON0, COUT		;    ?
			GOTO	MTM_MET040_YES		; 
										; 
			btfsc	PIR1, TMR1IF		; Ҩ  ?
			GOTO	MTM_EXIT_ERROR		;

		;	movlw	0x01				;  ?
			decf	METAKOM_COUNT_BIT, W;
			btfss	STATUS, Z			;
			GOTO	MTM_CYCL20			; 

			movf	TEMP0_TMR0, W
			subwf	TMR0, W
			addwf	LEN_TMR0, W
			subwf	LEN_TAU, W
			btfsc	STATUS, C
			GOTO	MTM_CYCL20			; 
MTM_MET040_YES
			MOVF	TMR0, W				;    0
			MOVWF	TEMP1_TMR0			;
			
			MOVF	TEMP0_TMR0, W		;    
			SUBWF	TEMP1_TMR0, W		;
			MOVWF	LEN2_TMR0			;

			MOVF	LEN2_TMR0, W		;    
			SUBWF	LEN_TMR0, W			; LEN_TMR0 - LEN2_TMR0 (LEN_TMR0<LEN2_TMR0 |C=0| bit clear; LEN_TMR0>=LEN2_TMR0 |C=1| bit set)
			rlf		RS232BUF+5, F		;
			rlf		RS232BUF+4, F		;
			rlf		RS232BUF+3,	F		;
			rlf		RS232BUF+2, F		;
;			RlF		CYFRAL_BYTE, F

;			MOVF	LEN_TMR0, W			;    
;			SUBWF	LEN2_TMR0, W		; LEN2_TMR0 - LEN_TMR0 (LEN2_TMR0<LEN_TMR0 |C=0| bit clear; LEN2_TMR0>=LEN_TMR0 |C=1| bit set)
;			RrF		CYFRAL_BYTE, F

			MOVF	TEMP1_TMR0, W		;   TMR0   

			decfsz	METAKOM_COUNT_BIT, F	;   ?
			GOTO	MTM_CYCL10			; 

			;CHANGING PRESCALER (TIMER0 > WDT)
			banksel OPTION_REG			;
			movlw	b'00000111'			;
			movwf	OPTION_REG			;
			BANKSEL	TMR0 				;
			CLRWDT 						;Clear WDT
			CLRF	TMR0				;Clear TMR0 and prescaler
			BANKSEL	OPTION_REG			;
			BSF		OPTION_REG, PSA 	;Select WDT
			CLRWDT 						;
			MOVLW	b'11111000'			;Mask prescaler
			ANDWF	OPTION_REG,W 		;bits
		;	IORLW	b'00000101' 		;Set WDT prescaler
		;	MOVWF 	OPTION_REG ;to 1:32
			banksel TMR0

			;    

			movlw	RS232BUF+2
			call	CHECK_ODD

			goto	EXIT02
;################################################################################################
CHECK_ODD ;   
ODD_COUNT	equ		DALLAS1				;  
ODD_TEMP	equ		DALLAS2				;  
CO_CNTR_BIT	equ		CYFRAL_COUNT_BIT	;   
CO_CNTR_BYT	equ		CYFRAL_BYTE			;   

			banksel	ODD_COUNT
			movwf	FSR					;      4- 
			movlw	.4					;  
			movwf	CO_CNTR_BYT			;
ODD_MET05
			movf	INDF, W				;         7 
			movwf	ODD_TEMP			;
			movlw	.7					;
			movwf	CO_CNTR_BIT			;
			clrf	ODD_COUNT			;
			
ODD_MET10
			RLF		ODD_TEMP, F			;   
			btfsc	STATUS, C			;
			incf	ODD_COUNT, F		;
			decfsz	CO_CNTR_BIT, F		;
			goto	ODD_MET10			;

			movf	INDF, W				;     
			xorwf	ODD_COUNT, F		;
			btfsc	ODD_COUNT, 0		;
			return						;  (   )
			incf	FSR, F				;  
			decfsz	CO_CNTR_BYT, F		;
			goto	ODD_MET05			;

			bsf		FLAG_READ_CYFRAL	;  
			return						;  (     )

;################################################################################################
;     RS232BUF        ADRFSR
COPYBUFFS

			CLRF	RCount			;  ר
MET35
			;  ()      
            MOVF	RCount, W		; ׸
			ADDLW	RS232BUF
			MOVWF	FSR
			MOVF	INDF, 	W
			MOVWF	TEMP
			MOVF	ADRFSR, W
			MOVWF	FSR
			MOVF	RCount, W
			ADDWF	FSR, F
			MOVF	TEMP, W
			MOVWF	INDF

			INCF	RCount, F
			MOVF	RCount, W		;  
			XORLW	0X08			; 
			BTFSS	STATUS, Z		;  ?
			; 
			GOTO	MET35			; 8  ٨  
			; 
			CLRF	RCount
			return
;################################################################################################


;  EEPROM
			ORG 	0X00002100
			DE		START_EEPROM, MAX_EEPROM_683, 0xff,0xff
	;		DE		START_EEPROM, MAX_EEPROM_683, 0x03,0xff
			DE		"sprinter4wd.narod.ru "
			DE		"sprinter4wd.narod.ru "
			DE		"sprinter4wd.narod.ru "
			DE		"sprinter4wd.narod.ru "
			DE		"sprinter4wd.narod.ru "
			DE		"sprinter4wd.narod.ru "

            END
